Woodstock Blog

a tech blog for general algorithmic interview questions

[LeetCode 1] Two Sum

Question

link

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

Stats

Frequency 5
Diffficulty 2
Adjusted Difficulty 3
Time to use ----------

Ratings/Color = 1(white) 2(lime) 3(yellow) 4/5(red)

Analysis

It’s not a good idea to sort the input, because we are supposed to return the position index. Without sorting, we must use some data structure to help us!

And the answer is HashMap.

Solution

Read thru the list of integers, and each time add (targer - curInt) to the hashmap.

If the number is contained in the HashMap, solution found.

My code

public class Solution {
    public int[] twoSum(int[] numbers, int target) {
        int[] result = new int[2];
        if (numbers == null || numbers.length == 1) {
            return result;
        }
        HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();
        for (int i = 0; i < numbers.length; i++) {
            if (map.containsKey(numbers[i])) {
                result[0] = map.get(numbers[i]) + 1;
                result[1] = i + 1;
                return result;
            } else {
                // put <key, value> into hashmap where key is the number 
                // that would complement the sum to be target. Like this: 
                map.put(target - numbers[i], i);
            }
        }
        return result;
    }
}